// PROFILE.H
//
// Profiling functions and information
//
// Copyright (C) 1999 Sander van der Wal
//
// $Id: profile.h 1.1 2000-09-17 13:39:34+02 svdwal Exp svdwal $

#ifndef __PROFILE_H__
#define __PROFILE_H__

// put your own funcs here
// the functions that are being profiled


#define PROFILE_NAME_00 "CPdfDocument::DoOpenFileL"
#define CPDFDOCUMENT__DOOPENFILEL   0

#define PROFILE_NAME_01 "CPdfDocView::DisplayPage"
#define CPDFDOCVIEW__DISPLAYPAGE    1

#define PROFILE_NAME_02 "Page::display" 
#define PAGE__DISPLAY   2

#define PROFILE_NAME_03 "Gfx::go"
#define GFX__GO         3

#define PROFILE_NAME_04 "Gfx::execOp" 
#define GFX__EXECOP     4

#define PROFILE_NAME_05 "Parser::getObj"
#define PARSER__GETOBJ  5

#define PROFILE_NAME_06 "Parser::shift"
#define PARSER__SHIFT   6

#define PROFILE_NAME_07 "Lexer::getObj"
#define LEXER__GETOBJ   7

#define PROFILE_NAME_08 "Gfx::doShowText"
#define GFX__DOSHOWTEXT 8

#define PROFILE_NAME_09 "GfxFont::getWidth"
#define GFXFONT__GETWIDTH 9

#define PROFILE_NAME_10 "CFbsBitmapOutputDev::updateFont" 
#define CFBSBITMAPOUTPUTDEV__UPDATEFONT  10

#define PROFILE_NAME_11 "CFbsBitmapOutputDev::drawString" 
#define CFBSBITMAPOUTPUTDEV__DRAWSTRING  11

#define PROFILE_NAME_12 "CFbsBitmapOutputDev::drawChar"
#define CFBSBITMAPOUTPUTDEV__DRAWCHAR    12

#define PROFILE_NAME_13 "CEpocFontCache::Search"
#define CEPOCFONTCACHE__SEARCH 13

#define PROFILE_NAME_14 "CGraphicsContext::DiscardFont"
#define CGRAPHICSCONTEXT__DISCARDFONT 14

#define PROFILE_NAME_15 "CGraphicsContext::UseFont"
#define CGRAPHICSCONTEXT__USEFONT 15

#define PROFILE_NAME_16 "Object::fetchL"
#define OBJECT__FETCHL 16

#define PROFILE_NAME_17 "Dict::find"
#define DICT__FIND 17

#define PROFILE_MAX 17 // the last function that is being profiled

#ifdef TRACE

#  ifndef __E32SVR_H__
#    include <e32svr.h> // profiling functions
#  endif

#  ifndef       __PROFILE_EXTERNALS_INCLUDED__
extern "C" void __profile_dump();
#    define     __PROFILE_EXTERNALS_INCLUDED__
#  endif

#  define PROFILE_INIT() RDebug::ProfileReset(0, PROFILE_MAX)
#  define PROFILE_START(aNum) RDebug::ProfileStart(aNum)
#  define PROFILE_STOP(aNum) RDebug::ProfileEnd(aNum)
#  define PROFILE_DUMP() __profile_dump()

#else

#  define PROFILE_INIT()
#  define PROFILE_START(aNum)
#  define PROFILE_STOP(aNum)
#  define PROFILE_DUMP()

#endif // TRACE

#endif // __PROFILE_H__